#!/bin/csh

set file_has_id = "../../Game/Application/FFAppContext.cpp"
set pidlist = `grep PRODUCT_ID $file_has_id | grep define | sed '/\/\//d' | awk '{print $3}' | sed 's/"//g'`  
set pid = $pidlist[$#pidlist]

switch ($pid)
    case "ffs.dev.android":
        set server = "http://ffs-dev-scene2.socialgamenet.com/mobile.php"
        breaksw
    case "ffs.dev.iOS":
        set server = "http://ffs-dev-scene2.socialgamenet.com/mobile.php"
        breaksw
    case "ffs.dev.wp":
        set server = "http://ffs-dev-scene2.socialgamenet.com/mobile.php"
        breaksw
    case "ffs.beta.iOS":
        set server = "http://farm-mobile-testflight.socialgamenet.com/mobile.php"
        breaksw
    case "ffs.beta.android":
        set server = "http://farm-mobile-androidtest.socialgamenet.com/mobile.php"
        breaksw
    case "ffs.global.iOS"
        set server = "http://ffs-global.funplusgame.com/mobile.php"
        breaksw
    case "ffs.global.android"
        set server = "http://ffs-global.funplusgame.com/mobile.php"
        breaksw
    case "ffs.global.tango"
        set server = "http://ffs-tango.funplusgame.com/mobile.php"
        breaksw
    case "ffs.global.amazon"
        set server = "http://ffs-amazon.funplusgame.com/mobile.php"
        breaksw
    case "ffs.cn.iOS"
        set server = "http://ffs-cn.ifunplus.cn/mobile.php"
        breaksw
    case "ffs.cn.android"
        set server = "http://ffs-cn.ifunplus.cn/mobile.php"
        breaksw
    case "ffs.cn.360"
        set server = "http://ffs-cn.ifunplus.cn/mobile.php"
        breaksw
    case "ffs.cn.xiaomi"
        set server = "http://ffs-cn.ifunplus.cn/mobile.php"
        breaksw
    default:
        set server = ""
        breaksw
endsw

#use below server when local packaging is available
if ( $#argv < 2) then
    set server = "http://farm-mobile-test.socialgamenet.com/mobile.php" ## "http://10.0.34.46/mobile.php"
else
   set server = $1
endif
set param = "controller=mobileuser&gmt_debug=true&action=getConfigForClientRelease&lang=" 
if ( $#argv < 1 ) then
    set version = ""
elif ( $#argv < 2 ) then
    set version = "&version="$1
else
    set version = "&version="$1
endif

set langs = ( "en" \
#    "zh-Hans" \
#    "zh-Hant" \
#    "ja"      \
#    "pt"      \
#    "ar-AE"   \
#    "it"      \
#    "th"      \
#    "ko"      \
#    "de"      \
#    "fr"      \
#    "nl"      \
#    "tr"      \
#    "pl"      \
#    "es"      \
#    "nb"      \
#    "ru-RU"   \
#    "id"      \
#    "sv-SE"   \
)

set prefix = "config"

echo "-----------------START-----------------"

echo "-server = " $server
echo "-productid = " $pid

echo -n $server > config_server.txt

foreach lan ($langs)
    echo  "--get config of launuage : " $lan
    echo ${server}\?${param}$lan$version
    curl $server\?${param}$lan$version > ${prefix}_$lan
    if ( ! -z ${prefix}_$lan ) then
        zip -m -9 ${prefix}_$lan.zip ${prefix}_$lan
    else
        rm -rf ${prefix}_$lan
        echo " **failed**"
    endif
end
 
echo "-----------------DONE-----------------"
