attribute vec4 a_position;
attribute vec2 a_texCoord;
attribute vec4 a_color;

//关于场景的一些参数
uniform vec4 v_sceneParams;
uniform float f_timer;

varying vec2 v_texCoord;

void main()
{   
    v_texCoord = a_texCoord;
    
    //场景的一半宽度和一半高度
    float f_sceneHalfWidth =v_sceneParams.x*0.5;
    float f_sceneHalfHeight=v_sceneParams.y*0.5;
    
    //太阳光随着波浪起伏
    vec2 vFragPos =vec2((a_position.x +1.5)*f_sceneHalfWidth, (a_position.y+1.5)*f_sceneHalfHeight);
    vec2 vOff =normalize(vec2(vFragPos.x -f_sceneHalfWidth,vFragPos.y -f_sceneHalfHeight));
    float fTextDist =(vFragPos.y  + f_timer);
    fTextDist =sin(fTextDist*0.05)/500.0;
    
    gl_Position = vec4(a_position.x +fTextDist*vOff.x,a_position.y + fTextDist*vOff.y,a_position.z,a_position.w);
}
