
precision highp float;

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform sampler2D CC_Texture0;
uniform sampler2D CC_Texture1;
uniform sampler2D u_sinTable;

uniform vec4 v_noise;
uniform vec4 v_texParams;

vec3 waveNormal(vec2 p) {

    p.x = p.x * v_texParams.x;
    p.y = p.y * v_texParams.y;
    
    vec3 normal = texture2D(CC_Texture1, p).xyz;
    normal = -1.0 + normal * 2.0;
    return normalize(normal);
}

float sint(float x)
{
    return texture2D(u_sinTable,vec2(x*0.0795775,0)).r * 2.0 - 1.0;
}

void main()
{
    vec2 texCoord = v_texCoord;
    
    texCoord.x = texCoord.x + v_noise.x;
    texCoord.y = texCoord.y + v_noise.y;
    
    // simple UV animation
    vec3 normal = waveNormal(texCoord);
    // simple calculate refraction UV offset
    vec2 p = vec2(texCoord.x*2.0-1.0,texCoord.y*2.0-1.0);
    vec3 eyePos = vec3(0.0, 0.0, 100.0);
    vec3 inVec = normalize(vec3(p, 0.0) - eyePos);
    vec3 refractVec = refract(inVec, normal, 0.7);
    
    vec2 vecTexCoord = v_texCoord.xy + refractVec.xy *v_noise.z;
    
    vec4 finalColor = v_fragmentColor * texture2D(CC_Texture0, vecTexCoord);
    gl_FragColor = finalColor;
}

