
precision highp float;

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform vec4 v_noise;
uniform vec4 v_effect;

uniform sampler2D CC_Texture0;
uniform sampler2D CC_Texture1;
uniform sampler2D u_sinTable;
uniform sampler2D CC_TextureBottom;

uniform float pondTime;

vec3 waveNormal(vec2 p) {
    vec3 normal = texture2D(CC_Texture1, p).xyz;
    normal = -1.0 + normal * 2.0;
    return normalize(normal);
}

float sint(float x)
{
    return texture2D(u_sinTable,vec2(x*0.0795775,0)).r * 2.0 - 1.0;
}

void main()
{
    vec2 texCoord = v_texCoord;
    
    texCoord.x = texCoord.x + v_noise.x;
    texCoord.y = texCoord.y + v_noise.x;
    
    // simple UV animation
    vec3 normal = waveNormal(texCoord);
    // simple calculate refraction UV offset
    vec2 p = vec2(texCoord.x*2.0-1.0,texCoord.y*2.0-1.0);
    
    vec3 eyePos = vec3(0.0, 0.0, 100.0);
    vec3 inVec = normalize(vec3(p, 0.0) - eyePos);
    vec3 refractVec = refract(inVec, normal, v_effect.x);
    
    vec2 vecTexCoord = v_texCoord.xy + refractVec.xy * abs(sint(pondTime + gl_FragCoord.y*v_noise.y))*v_noise.z + v_noise.w;
    vec4 col = texture2D(CC_Texture0, vecTexCoord);
    vec4 col2 = col*col;
    
//    vec4 col3 = texture2D(CC_TextureBottom, vecTexCoord);
    vec4 color = col*v_effect.y + col2*(1.0 - v_effect.y);
    
//    gl_FragColor = col3*0.2 + color*0.8;
    gl_FragColor = color;
}

