precision highp float;

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform sampler2D CC_Texture0;

uniform float f_snowValue;
uniform vec2 v_sPixel;

float getSnowAlpha(vec4 color)
{
    float cc = color.r * 0.3 + color.g * 0.59 + color.b * 0.11;
//    float cc = max(color.r,color.g);
//    cc = max(cc, color.b);
    
    float base0 = f_snowValue;
    float cc1 = (cc - base0)*255.0;
    cc1 = clamp(cc1,0.0,1.0)*0.91;
    return cc1;
}

void main()
{
    float pixel1 = v_sPixel.x;
    float pixel2 = v_sPixel.y;
    
    float colorSum = 0.0;
    
    colorSum += getSnowAlpha(texture2D(CC_Texture0, vec2(v_texCoord.x - pixel2, v_texCoord.y))) * 0.006592;
    colorSum += getSnowAlpha(texture2D(CC_Texture0, vec2(v_texCoord.x - pixel1, v_texCoord.y))) * 0.194214;
    colorSum += getSnowAlpha(texture2D(CC_Texture0, v_texCoord)) * 0.598145;
    colorSum += getSnowAlpha(texture2D(CC_Texture0, vec2(v_texCoord.x + pixel1, v_texCoord.y))) * 0.194214;
    colorSum += getSnowAlpha(texture2D(CC_Texture0, vec2(v_texCoord.x + pixel2, v_texCoord.y))) * 0.006592;
    
    gl_FragColor = vec4(colorSum,colorSum,colorSum,1.0);
}


