#ifdef GL_ES
precision mediump float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform vec4 v_flashColor;
uniform sampler2D u_texture;
uniform float time;

void main()
{
    vec4 basic_color = texture2D(u_texture, v_texCoord);
    
    vec3 flashColor = basic_color.rgb*2.0;
    
    flashColor = flashColor * v_flashColor.rgb;
    flashColor = flashColor * flashColor;
    
    basic_color.rgb = basic_color.rgb *0.8 + flashColor * time * 0.5;
    basic_color.rgb = basic_color.rgb * basic_color.a;

	gl_FragColor = v_fragmentColor * basic_color;
}









